| OpendTect 8.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
TypeSet< T > Class Template Reference
Basic

Sets of (small) copyable elements. More...

`#include <typeset.h>`

Inherits OD::ValVec< T, od_int32 >.

Inherited by PolyLineND< T >.

## Public Types
typedef OD::ValVec< T, od_int32 >::idx_type | idx_type
typedef OD::ValVec< T, od_int32 >::size_type | size_type
Public Types inherited from OD::ValVec< T, od_int32 >
typedef impl_type::const_iterator | const_iterator
typedef const value_type & | const_reference
typedef size_type | difference_type
typedef size_type | idx_type
typedef impl_type::iterator | iterator
typedef T | object_type
typedef value_type & | reference
typedef od_int32 | size_type
typedef T | value_type

## Public Member Functions
| TypeSet ()
| TypeSet (const T *t, size_type nr)
| TypeSet (const TypeSet &oth)
| TypeSet (size_type nr, T typ)
| TypeSet (T typ)
| ~TypeSet ()
TypeSet * | clone () const override
Public Member Functions inherited from OD::ValVec< T, od_int32 >
virtual | ~ValVec ()
ValVec & | add (const T &)
virtual bool | addIfNew (const T &)
virtual bool | append (const T *, size_type)
virtual bool | append (const ValVec &)
virtual T * | arr ()
| 3rd party access
virtual const T * | arr () const
iterator | begin ()
const_iterator | begin () const
const_iterator | cbegin () const
const_iterator | cend () const
virtual ValVec & | copy (const T *, size_type)
virtual ValVec & | copy (const ValVec &)
size_type | count (const T &) const
virtual void | createDifference (const ValVec &, bool must_preserve_order=false)
| Removes all items present in other set.
virtual void | createIntersection (const ValVec &)
| Only keeps common items.
virtual void | createUnion (const ValVec &)
void | emplace_back (Args &&... args)
bool | empty () const
iterator | end ()
const_iterator | end () const
void | erase () override
T & | first ()
const T & | first () const
T & | get (idx_type)
const T & | get (idx_type) const
virtual size_type | getCapacity () const
idx_type | getIdx (const_iterator it) const
idx_type | getIdx (iterator it) const
virtual idx_type | indexOf (T, bool forward=true, idx_type start=-1) const
virtual void | insert (idx_type, const T &)
bool | isPresent (const T &) const
T & | last ()
const T & | last () const
size_type | max_size () const
virtual void | move (idx_type from, idx_type to)
od_int64 | nrItems () const override
bool | operator!= (const ValVec &oth) const
ValVec & | operator+= (const T &t)
ValVec & | operator-= (const T &t)
ValVec & | operator= (const ValVec &oth)
bool | operator== (const ValVec &) const
T & | operator[] (idx_type i)
const T & | operator[] (idx_type i) const
T | pop ()
bool | push (const T &)
virtual void | removeRange (idx_type from, idx_type to)
virtual void | removeSingle (idx_type, bool preserver_order=true)
void | replace (T, T)
void | reverse () override
void | setAll (T)
virtual bool | setCapacity (size_type sz, bool withmargin)
virtual bool | setSize (size_type sz, T val=T())
size_type | size () const
void | swap (od_int32, od_int32)
void | swap (ValVec &oth)
void | swapItems (od_int64 i1, od_int64 i2) override
virtual void | useIndexes (const idx_type *)
bool | validIdx (od_int64) const override
std::vector< T > & | vec ()
const std::vector< T > & | vec () const
Public Member Functions inherited from OD::Set
virtual | ~Set ()
bool | isEmpty () const
void | setEmpty ()

## Additional Inherited Members
Static Public Member Functions inherited from OD::Set
static od_int32 | maxIdx32 ()
static od_int64 | maxIdx64 ()
Protected Types inherited from OD::ValVec< T, od_int32 >
typedef VectorAccess< T, od_int32 > | impl_type
Protected Member Functions inherited from OD::ValVec< T, od_int32 >
| ValVec ()
| ValVec (const T *, size_type nr)
| ValVec (const ValVec &)
| ValVec (size_type nr, T typ)
T * | gtArr () const
Protected Attributes inherited from OD::ValVec< T, od_int32 >
impl_type | vec_

## Detailed Description

template<class T>
class TypeSet< T >

Sets of (small) copyable elements.

TypeSet/LargeValVec are meant for simple types or small objects that have a copy constructor. The ‘-=’ operator will only remove the first occurrence that matches using the ‘==’ operator. The requirement of the presence of that operator is actually not that bad: at least you can't forget it.

Do not make TypeSet<bool> (don't worry, it won't compile). Use the BoolTypeSet typedef just after the class definition. See vectoraccess.h for details on why.

<>

## Member Typedef Documentation

## ◆ idx_type

template<class T >

typedef OD::ValVec<T,od_int32>::idx_type TypeSet< T >::idx_type

## ◆ size_type

template<class T >

typedef OD::ValVec<T,od_int32>::size_type TypeSet< T >::size_type

## Constructor & Destructor Documentation

## ◆ TypeSet() [1/5]

template<class T >

TypeSet< T >::TypeSet | ( |  | ) |
| inline

## ◆ TypeSet() [2/5]

template<class T >

TypeSet< T >::TypeSet | ( | size_type | nr,
|  | T | typ )
| inline

## ◆ TypeSet() [3/5]

template<class T >

TypeSet< T >::TypeSet | ( | T | typ | ) |
| inline explicit

## ◆ TypeSet() [4/5]

template<class T >

TypeSet< T >::TypeSet | ( | const T * | t,
|  | size_type | nr )
| inline

## ◆ TypeSet() [5/5]

template<class T >

TypeSet< T >::TypeSet | ( | const TypeSet< T > & | oth | ) |
| inline

## ◆ ~TypeSet()

template<class T >

TypeSet< T >::~TypeSet | ( |  | ) |
| inline

## Member Function Documentation

## ◆ clone()

template<class T >

TypeSet * TypeSet< T >::clone | ( |  | ) | const
| inline override virtual

Implements OD::ValVec< T, od_int32 >.

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025